class CMapper15:public CMapper
	{
	public:
		CMapper15()
			{
			number = 15;
			message("'100-in-1 Contra Function 16' mapper loaded\n");
			}
		void Reset()
			{
			SetWriteHandled(0x8,0xF);
			Write(0x8000,0);
			nes.SetSizeVRAM(8);
			}
		void Write(u32 addr,u8 data)
			{
			int bank,banks[4],xor;
			
			bank = (data << 1) & 0x7E;
			xor = (data >> 7) & 1;
			switch(addr & 3)
				{
				case 0:
					banks[0] = bank | 0;
					banks[1] = bank | 1;
					banks[2] = bank | 2;
					banks[3] = bank | 3;
					break;
				case 1:
					banks[0] = bank | 0;
					banks[1] = bank | 1;
					banks[2] = 0x7E;
					banks[3] = 0x7F;
					break;
				case 2:
					banks[0] = bank;
					banks[1] = bank;
					banks[2] = bank;
					banks[3] = bank;
					break;
				case 3:
					banks[0] = bank | 0;
					banks[1] = bank | 1;
					banks[2] = bank | 0;
					banks[3] = bank | 1;
					break;
				}
			nes.SetPageCPU8(0x8,banks[0] ^ xor);
			nes.SetPageCPU8(0xA,banks[1] ^ xor);
			nes.SetPageCPU8(0xC,banks[2] ^ xor);
			nes.SetPageCPU8(0xE,banks[3] ^ xor);
			nes.ppu->SetMirroring((~data >> 6) & 1);
			}
	};
