class CMapper234:public CMapper
	{
	public:
		int Reg[2];
	public:
		CMapper234()
			{
			number = 234;
			message("D-1012 mapper loaded\n");
			}
		void Reset()
			{
			SetWriteHandled(0xF,0xF);
			Reg[0] = 0;
			Reg[1] = 0;
			Sync();
			}
		void Sync()
			{
			if(Reg[0] & 0x40)
				{
				nes.SetPageCPU32(8,(Reg[0] & 0xE) | (Reg[1] & 1));
				nes.SetPagePPU8(0,((Reg[0] & 0xE) << 2) | ((Reg[1] >> 4) & 7));
				}
			else
				{
				nes.SetPageCPU32(8,Reg[0] & 0xF);
				nes.SetPagePPU8(0,((Reg[0] & 0xF) << 2) | ((Reg[1] >> 4) & 3));
				}
			nes.ppu->SetMirroring(~Reg[0] >> 7);
			}
		void Write(u32 addr,u8 data)
			{
			switch(addr & 0xFFF8)
				{
				case 0xFF80:
				case 0xFF88:
				case 0xFF90:
				case 0xFF98:
					if(Reg[0] == 0)
						Reg[0] = data;
					Sync();
					break;
				case 0xFFE8:
				case 0xFFF0:
				case 0xFFF8:
					Reg[1] = data;
					Sync();
					break;
				}
			}
	};
