class CMapper41:public CMapper
	{
	public:
		int Reg[2];
	public:
		CMapper41()
			{
			number = 41;
			message("'Caltron 6-in-1' mapper loaded\n");
			}
		void Reset()
			{
			SetWriteHandled(0x6,0xF);
			Reg[0] = 0;
			Reg[1] = 0;
			Sync();
			}
		void Sync()
			{
			nes.SetPageCPU32(8,Reg[0] & 7);
			nes.SetPagePPU8(0,((Reg[0] & 0x18) >> 1) | (Reg[1] & 3));
			nes.ppu->SetMirroring(((~Reg[0]) >> 5) & 1);
			}
		void Write(u32 addr,u8 data)
			{
			if(addr < 0x6800)
				Reg[0] = addr & 0x3F;
			else if(addr >= 0x8000 && Reg[0] & 4)
				Reg[1] = data & 3;
			Sync();
			}
	};
