class CMapper7:public CMapper
	{
	public:
		CMapper7()
			{
			number = 7;
			message("AOROM mapper loaded\n");
			}
		void Reset()
			{
			SetWriteHandled(0x8,0xF);
			nes.SetPageCPU32(8,0);
			if(nes.chrsize)
				nes.SetPagePPU8(0,0);
			else
				nes.SetSizeVRAM(8);
			nes.ppu->SetMirroring(MIRROR_1L);
			}
		void Write(u32 addr,u8 data)
			{
			nes.SetPageCPU32(0x8,data & 0xf);
			if(data & 0x10)
				nes.ppu->SetMirroring(MIRROR_1H);
			else
				nes.ppu->SetMirroring(MIRROR_1L);
			}
	};
