class CMapper34:public CMapper
	{
	public:
		CMapper34()
			{
			number = 34;
			message("NINA-001/BNROM mapper loaded\n");
			}
		void Reset()
			{
			SetWriteHandled(0x7,0xF);
			nes.SetPageCPU32(8,0);
			if(nes.chrsize)
				nes.SetPagePPU8(0,0);
			else
				nes.SetSizeVRAM(8);
			}
		void Write(u32 addr,u8 data)
			{
			if(addr >= 0x8000)
				nes.SetPageCPU32(8,data);
			else
				{
				switch(addr)
					{
					case 0x7FFD:
						nes.SetPageCPU32(8,data);
						break;
					case 0x7FFE:
						if(nes.chrsize)
							nes.SetPagePPU4(0,data);
						break;
					case 0x7FFF:
						if(nes.chrsize)
							nes.SetPagePPU4(4,data);
						break;
					}
				}
			}
	};
