class CMapper45:public CMMC3
	{
	public:
		int Regs[4];
		int WriteNum;
	public:
		CMapper45()
			{
			number = 45;
			message("'Super 1000000-in-1' mapper loaded\n");
			}
		void Reset()
			{
			Regs[0] = 0;
			Regs[1] = 0;
			Regs[2] = 0;
			Regs[3] = 0;
			WriteNum = 0;
			SetWriteHandled(0x6,0x7);
			CMMC3::Reset();
			}
		int GetPRG(int bank)
			{
			return(CMMC3::GetPRG(bank) & ((Regs[3] ^ 0xFF) & 0x3F) | Regs[1]);
			}
		int GetCHR(int bank)
			{
			u8 table[16] = {0,0,0,0,0,0,0,0,0x1,0x3,0x7,0xF,0x1F,0x3F,0x7F,0xFF};
			int ret = CMMC3::GetCHR(bank);
			
			ret &= table[Regs[2] & 0xF];
			ret |= Regs[0];
			ret |= (Regs[2] & 0x10) << 4;
			return(ret);
			}
		void Write(u32 addr,u8 data)
			{
			//message("mapper45: write $%04X = $%02X\n",addr,data);
			CMMC3::Write(addr,data);
			if((Regs[3] & 0x40) == 0)
				{
				Regs[WriteNum++] = data;
				if(WriteNum == 4)
					WriteNum = 0;
				}
			}
	};
