class CMapper47:public CMMC3
	{
	public:
		int Bank;
	public:
		CMapper47()
			{
			number = 47;
			message("NES-QJ mapper loaded\n");
			}
		void Reset()
			{
			SetWriteHandled(0x6,0x7);
			CMMC3::Reset();
			}
		int GetPRG(int bank)
			{
			return(CMMC3::GetPRG(bank) | (Bank << 4));
			}
		int GetCHR(int bank)
			{
			return(CMMC3::GetCHR(bank) | (Bank << 7));
			}
		void Write(u32 addr,u8 data)
			{
			if((addr & 0xE000) == 0x6000)
				Bank = data & 1;
			else
				CMMC3::Write(addr,data);
			}
	};
