#ifndef __video_h__
#define __video_h__

#include "types.h"

class CVideo
	{
	public:
		s32 width,height,bpp;
	public:
		CVideo(){}
		virtual int Init(HWND wnd,HINSTANCE inst,int w,int h,int bpp=0){return(0);}	//init video interface
		virtual void Kill(){}						//destroy video interface
		virtual void Resize(){}						//hwnd changed size, acknowledge
		virtual void StartBlit(){}					//beginning of frame, start blit
		virtual void StopBlit(){}					//end of frame, no more drawing allowed
		virtual void *GetSurface(){return(0);}	//pointer to surface
		virtual int GetPitch(){return(0);}		//line size (in bytes) of surface
	};

#endif